<?php
define("MBW_REQUEST_MODE", "API");
if(!defined('_MB_')) exit();

do_action('mbw_user_api_init');

if(mbw_get_param("board_action")=="login" || mbw_get_param("board_action")=="user_find_id" || mbw_get_param("board_action")=="modify_password" || mbw_get_param("board_action")=="reset_password"){
	if(!mbw_verify_nonce()){
		mbw_error_message("MSG_NONCE_MATCH_ERROR", "","1401");
	}
}

global $wpdb;
$query_command		= "";
$send_data					= array();
$where_data				= array();
$query_data				= array();


do_action('mbw_user_api_header');

if($mstore->get_result_data("state")=="error"){
	echo mbw_data_encode($mstore->result_data);	
	exit;
}

if(mbw_get_param("board_action")=="login"){

	if(mbw_get_param("user_id")==""){
		mbw_error_message("MSG_FIELD_EMPTY_ERROR1", $mb_languages["W_ID"]);
	}else if(mbw_get_param("user_password")==""){
		mbw_error_message("MSG_FIELD_EMPTY_ERROR1", $mb_languages["W_PASSWORD"]);
	}else{
		$user_id				= mbw_get_param("user_id");
		$user_passwd		= mbw_get_param("user_password");
		$user_remember	= mbw_get_param("rememberme");
		$user_mode		= mbw_get_option("user_mode");
		$user_id				= trim($user_id);
		$user_passwd		= trim($user_passwd);

		if(!empty($user_remember)){
			$user_remember		= true;
		}else{
			$user_remember		= false;
		}		
		if($user_mode=="WP"){
			$user_hash			= ($mdb->get_var($mdb->prepare("select user_pass from `".$wpdb->users."` where user_login=%s", $user_id)));			
		}else{
			$user_hash			= ($mdb->get_var($mdb->prepare("select ".$mb_fields["users"]["fn_passwd"]." from `".$mb_admin_tables["users"]."` where `".$mb_fields["users"]["fn_user_id"]."`=%s limit 1", $user_id)));
		}

		if(empty($user_hash)){
			mbw_error_message("MSG_EXIST_ERROR", $mb_languages["W_ID"]);	
		}else if(mbw_check_password($user_passwd, $user_hash)){
			//비밀번호가 일치하면 로그인 쿠키 생성
			if($user_mode=="WP" && get_current_user_id()==0 ){
				$wp_user = wp_signon(array("user_login"=>$user_id,"user_password"=>$user_passwd,"remember"=>$user_remember));
				if(is_wp_error($wp_user)) mbw_error_message($wp_user->get_error_message());
			}

			if($mstore->get_result_data("state")!="error"){
				$expire		= 0;
				if($user_remember) $expire		= time() + 7776000;
				mbw_generate_auth_cookie($user_id,$user_mode,$expire);
				$mdb->query($mdb->prepare("update ".$mb_admin_tables["users"]." set ".$mb_fields["users"]["fn_user_access_token"]."='".mbw_generate_access_token()."' where ".$mb_fields["users"]["fn_user_id"]."=%s", $user_id));
			}
		}else{
			mbw_error_message("MSG_MATCH_ERROR",$mb_languages["W_PASSWORD"]);			
		}
	}	

}else if(mbw_get_param("board_action")=="logout"){
	mbw_logout();
}else if(mbw_get_param("board_action")=="menu"){
	$menu_field		= "*";
	$select_query		= mbw_get_add_query(array("column"=>$menu_field,"table"=>$mb_admin_tables["users"]));
	$user_data			= $mdb->get_row($mdb->prepare($select_query." where ".$mb_fields["users"]["fn_pid"]."=%d", mbw_get_param("pid")),ARRAY_A);
	
	$menu_body		= array();
	$menu_options	= mbw_get_param("option");

	$board_type		= mbw_get_board_option("fn_board_type");

	if(($board_type!="admin" && $board_type!="custom")){
		if(strpos($menu_options, 'search')!==false) $menu_body[]		= '<a href="'.mbw_get_url( array("board_pid"=>"","mode"=>"list","board_page"=>1,"search_field"=>"","search_text"=>"","category1"=>mbw_get_param("category1"),"category2"=>mbw_get_param("category2"),"category3"=>mbw_get_param("category3"),"list_type"=>mbw_get_param("list_type")) ).'&search_field=fn_user_pid&search_text='.$user_data[$mb_fields["users"]["fn_pid"]].'"><span>'.__MW("W_USER_SEARCH").'</span></a>';
	}

	if($mb_user_level>=10 && strpos($menu_options, 'email')!==false && !empty($user_data[$mb_fields["users"]["fn_user_email"]])) $menu_body[]		= '<a href="mailto:'.$user_data[$mb_fields["users"]["fn_user_email"]].'"><span>'.__MW("W_USER_EMAIL").'</span></a>';
	if(strpos($menu_options, 'homepage')!==false && !empty($user_data[$mb_fields["users"]["fn_user_homepage"]])) $menu_body[]		= '<a href="'.$user_data[$mb_fields["users"]["fn_user_homepage"]].'" target="_blank"><span>'.__MW("W_USER_HOMEPAGE").'</span></a>';
	if(strpos($menu_options, 'blog')!==false && !empty($user_data[$mb_fields["users"]["fn_user_blog"]])) $menu_body[]		= '<a href="'.$user_data[$mb_fields["users"]["fn_user_blog"]].'" target="_blank"><span>'.__MW("W_USER_BLOG").'</span></a>';

	if(has_filter('mf_user_popup_menu')) $menu_body			= apply_filters("mf_user_popup_menu",$menu_body);
	$menu_data["head"]						= "";
	$menu_data["user"]						= array("name"=>$user_data[$mb_fields["users"]["fn_user_name"]],"point"=>$user_data[$mb_fields["users"]["fn_user_point"]],"level"=>$user_data[$mb_fields["users"]["fn_user_level"]]);
	$menu_data["body"]						= $menu_body;
	$menu_data["foot"]						= "";		
	$mstore->set_result_data(array("data"=>$menu_data));
}else if(mbw_get_param("board_action")=="id_check"){
	$model_data				= mbw_json_decode(mbw_get_model("write"));
	foreach($model_data as $data){
		if(isset($data["field"]) && $data["field"]=="fn_user_id"){
			$user_id		= mbw_get_param("user_id");
			$user_id		= trim($user_id);
			if(!empty($data["pattern"]) && $user_id!=""){
				if(!mbw_check_pattern($data["pattern"],$user_id)){
					if(isset($data["pattern_error"])){
						$error_message		= mbw_get_message($data["pattern_error"]);
					}else{
						$error_message		= "MSG_PATTERN_ERROR";
					}
					mbw_error_message($error_message, $data["name"],"1203",str_replace("fn_", "", $data["field"]));				
				}else{
					//넘어온 유저 아이디로 아이디 존재하는지 체크하기
					$exist_check	= intval($mdb->get_var(mbw_get_add_query(array("column"=>"count(*)","table"=>$mb_admin_tables["users"]),array(array("field"=>"fn_user_id","value"=>mbw_get_param("user_id"))))));
					if(!empty($exist_check)){
						mbw_error_message("MSG_UNIQUE_ERROR", array(mbw_get_param("user_id"),"ID"),"1205",str_replace("fn_", "", $mb_fields["users"]["fn_user_id"]));
					}
				}
			}
			break;
		}
	}
}else if(mbw_get_param("board_action")=="modify_password"){

		$user_id			= mbw_get_user("fn_user_id");
		$user_id			= trim($user_id);
		$user_mode		= mbw_get_option("user_mode");

		if($user_mode=="WP"){			
			$user_hash			= ($mdb->get_var($mdb->prepare("select user_pass from `".$wpdb->users."` where user_login=%s", $user_id)));			
		}else{
			$user_hash			= ($mdb->get_var($mdb->prepare("select ".$mb_fields["users"]["fn_passwd"]." from `".$mb_admin_tables["users"]."` where `".$mb_fields["users"]["fn_user_id"]."`=%s limit 1", $user_id)));
		}

		if(mbw_check_password(mbw_get_param("passwd_old"), $user_hash)){
			//비밀번호가 일치하면 새로운 비밀번호로 수정
			$hashed			= mbw_hash_password(mbw_get_param("passwd"));
			$mdb->query($mdb->prepare("update ".$mb_admin_tables["users"]." set ".$mb_fields["users"]["fn_passwd"]."='".$hashed."' where ".$mb_fields["users"]["fn_user_id"]."=%s", $user_id));		
			
			if($user_mode=="WP"){				
				$wpdb->update( $wpdb->users, array( 'user_pass' => $hashed ), array( 'user_login' => $user_id ) );
				wp_logout();				
			}
			mbw_clear_auth_cookie();
		}else{
			mbw_error_message("MSG_MATCH_ERROR",$mb_languages["W_PASSWORD"]);
		}

}else if(mbw_get_param("board_action")=="reset_password"){
	//아이디와 이메일이 일치하는 회원 정보가 있으면 이메일로 새로운 비밀번호 발송

	$user_mode		= mbw_get_option("user_mode");
	$user_id			= mbw_get_param("user_id");
	$user_id			= trim($user_id);

	if($user_mode=="WP"){
		$exist_check	= intval($mdb->get_var(mbw_get_add_query(array("column"=>"count(*)","table"=>$wpdb->users),array(array("field"=>"user_login","value"=>$user_id),array("field"=>"user_email","value"=>mbw_get_param("user_email"))))));
	}else{
		$query		= mbw_get_add_query(array("column"=>"count(*)","table"=>$mb_admin_tables["users"]),array(array("field"=>"fn_user_id","value"=>$user_id),array("field"=>"fn_user_email","value"=>mbw_get_param("user_email"))))." AND (".$mb_fields["users"]["fn_user_platform"]."='mb' or ".$mb_fields["users"]["fn_user_platform"]."='wp');";
		$exist_check	= intval($mdb->get_var($query));
	}	

	if(!empty($exist_check)){		
		$key				= wp_generate_password( 8, false );		
		$hashed			= mbw_hash_password($key);

		$message		= "";
		$message		= $message.__MM("MSG_PASSWORD_RESET").$key;		

		$blogname		= get_bloginfo('name');
		$title				= sprintf( __('[%s] Password Reset'), $blogname );

		add_filter( 'wp_mail_from', 'mbw_paword_reset_mail_from' );
		function mbw_paword_reset_mail_from( $email ) {
			$from		= "";
			if(mbw_get_option("admin_email")!=""){
				$from	= mbw_get_option("admin_email");		//망보드 관리자 이메일
				if(strpos($from, ',')!==false){
					$email_array	= explode(",",$from);
					$from			= $email_array[0];
				}							
			}else $from	= get_option("admin_email");				//워드프레스 관리자 이메일
			return trim($from);
		}
		//메일 발송 이름 설정
		add_filter( 'wp_mail_from_name', 'mbw_paword_reset_mail_from_name' );
		function mbw_paword_reset_mail_from_name( $name ) {
			return get_bloginfo('name');
		}

		mbw_mail( mbw_get_param("user_email"), wp_specialchars_decode($title), $message, array('Content-Type: text/html; charset=UTF-8'));
		{
			if($user_mode=="WP"){
				$mdb->update( $mdb->wp_prefix."users", array( 'user_pass' => $hashed ), array( 'user_login' => $user_id ) );				
				$mdb->query($mdb->prepare("update ".$mb_admin_tables["users"]." set ".$mb_fields["users"]["fn_passwd"]."=%s where ".$mb_fields["users"]["fn_user_id"]."=%s and (".$mb_fields["users"]["fn_user_platform"]."='mb' or ".$mb_fields["users"]["fn_user_platform"]."='wp');", $hashed, $user_id));
			}else{
				$mdb->query($mdb->prepare("update ".$mb_admin_tables["users"]." set ".$mb_fields["users"]["fn_passwd"]."=%s where ".$mb_fields["users"]["fn_user_id"]."=%s and (".$mb_fields["users"]["fn_user_platform"]."='mb' or ".$mb_fields["users"]["fn_user_platform"]."='wp');", $hashed, $user_id));
			}
		}			
	}else{
		mbw_error_message("MSG_USER_NOT_EXIST");
	}
}else if(mbw_get_param("board_action")=="user_is_login"){
	$is_login		= "false";
	if(mbw_is_login()){
		$is_login		= "true";
	}
	$mstore->set_result_data(array("data"=>array("login"=>$is_login)));
}else if(mbw_get_param("board_action")=="user_find_id"){
	//아이디와 이메일이 일치하는 회원 정보가 있으면 이메일로 새로운 비밀번호 발송

	$user_mode		= mbw_get_option("user_mode");
	$user_id			= mbw_get_param("user_id");		
	$user_id			= trim($user_id);

	if($user_mode=="WP"){
		$user_id	= $mdb->get_var(mbw_get_add_query(array("column"=>"user_login","join"=>"none","table"=>$wpdb->users),array(array("field"=>"user_email","value"=>mbw_get_param("user_email"))))." order by ID desc limit 1;");
	}else{
		$user_id	= $mdb->get_var(mbw_get_add_query(array("column"=>"user_id","join"=>"none","table"=>$mb_admin_tables["users"]),array(array("field"=>"fn_user_email","value"=>mbw_get_param("user_email"))))." and (".$mb_fields["users"]["fn_user_platform"]."='mb' or ".$mb_fields["users"]["fn_user_platform"]."='wp') order by pid desc limit 1;");
	}	

	if(!empty($user_id)){
		$blogname		= get_bloginfo('name');
		$title				= "[".$blogname."] ".__MW("W_FIND_ID");
		$message		= __MW("W_YOUR_ID").": ".$user_id;

		add_filter( 'wp_mail_from', 'mbw_find_id_mail_from' );
		function mbw_find_id_mail_from( $email ) {
			$from		= "";
			if(mbw_get_option("admin_email")!=""){
				$from	= mbw_get_option("admin_email");		//망보드 관리자 이메일
				if(strpos($from, ',')!==false){
					$email_array	= explode(",",$from);
					$from			= $email_array[0];
				}							
			}else $from	= get_option("admin_email");				//워드프레스 관리자 이메일
			return trim($from);
		}
		//메일 발송 이름 설정
		add_filter( 'wp_mail_from_name', 'mbw_find_id_mail_from_name' );
		function mbw_find_id_mail_from_name( $name ) {
			return get_bloginfo('name');
		}

		mbw_mail( mbw_get_param("user_email"), wp_specialchars_decode($title), $message, array('Content-Type: text/html; charset=UTF-8'));
	}else{
		mbw_error_message("MSG_USER_NOT_EXIST");
	}
}

if($mstore->get_result_data("state")=="error"){
	echo mbw_data_encode($mstore->result_data);	
	exit;
}

do_action('mbw_user_api_footer');
echo mbw_data_encode($mstore->get_result_datas(array("state"=>"success")));	
exit;
?>