<?php
if(!function_exists('mbw_init_seo')){	
	function mbw_init_seo(){
		loadStyle(MBW_PLUGIN_URL."plugins/seo/css/style.css");
	}
}
add_action('admin_enqueue_scripts', 'mbw_init_seo');

if(!function_exists('mbw_init_seo_metabox')){	
	function mbw_init_seo_metabox(){
		add_action('add_meta_boxes', 'mbw_set_seo_metabox');
		add_action('save_post', 'mbw_save_seo_metabox');	
	}
}
if(!function_exists('mbw_set_seo_metabox')){	
	function mbw_set_seo_metabox( $post_type ) {
		$post_types			= array('post', 'page');
		if ( in_array( $post_type, $post_types )) 
			add_meta_box( 'mb_seo_meta', 'MangBoard SEO', 'mbw_add_seo_metabox', $post_type, 'normal', 'high' );
	}
}
if(!function_exists('mbw_add_seo_metabox')){	
	function mbw_add_seo_metabox(){
		if ( isset( $_GET['post'] ) ) {
			$post			= get_post($_GET['post']);
		}else{
			$post			= $GLOBALS['post'];
		}
		$seo				= mbw_get_seo_meta($post->ID);
		
		$title				= $seo["mb_seo_title"];
		$description	= $seo["mb_seo_description"];
		$keyword		= $seo["mb_seo_keyword"];

		$metabox		= "";
		$metabox		.= '<div style="padding:12px;border:1px solid #eee"><table cellspacing="0" cellpadding="0" border="0" class="table seo-metabox" style="width:100%;"><colgroup><col style="width:12%"><col></colgroup><tbody>';
		$metabox		.= '<tr><th scope="row"><label for="mb_seo_title">Title</label></th><td><input style="width:100%;" name="mb_seo_title" id="mb_seo_title" value="'.($title).'" type="text" maxlength="100"></td></tr>';	
		$metabox		.= '<tr><th scope="row"><label for="mb_seo_description">Description</label></th><td><input style="width:100%;" name="mb_seo_description" id="mb_seo_description" value="'.($description).'" type="text" maxlength="100"></td></tr>';
		$metabox		.= '<tr><th scope="row"><label for="mb_seo_keyword">Keyword</label></th><td><input style="width:100%;" name="mb_seo_keyword" id="mb_seo_keyword" value="'.($keyword).'" type="text" maxlength="100"></td></tr>';
		$metabox		.= '</tbody></table></div>';
		echo $metabox;	
	}
}
if(!function_exists('mbw_save_seo_metabox')){	
	function mbw_save_seo_metabox($post_id){
		if ( $post_id === null ) return false;

		if ( wp_is_post_revision( $post_id ) ) 
			$post_id = wp_is_post_revision( $post_id );

		$seo										= mbw_get_seo_meta();

		if(isset($_POST["mb_seo_title"])){
			$seo["mb_seo_title"]				= esc_attr($_POST["mb_seo_title"]);
		}
		if(isset($_POST["mb_seo_description"])){
			$seo["mb_seo_description"]	= esc_attr($_POST["mb_seo_description"]);
		}
		if(isset($_POST["mb_seo_keyword"])){
			$seo["mb_seo_keyword"]		= esc_attr($_POST["mb_seo_keyword"]);
		}
		if($seo["mb_seo_title"]!="" || $seo["mb_seo_description"]!="" || $seo["mb_seo_keyword"]!="")
			update_post_meta($post_id, 'mb_post_seo', $seo);
	}
}
add_action('admin_init', 'mbw_init_seo_metabox');

?>