<?php
require_once("sdk/facebook/autoload.php");

$fb = new \Facebook\Facebook([
  'app_id' => $social_data['facebook_id'],
  'app_secret' => $social_data['facebook_secret'],
  'default_graph_version' => 'v17.0',
  'persistent_data_handler'=>'session'
]);

$helper = $fb->getRedirectLoginHelper();
if(isset($_GET['state'])) {
    $helper->getPersistentDataHandler()->set('state', $_GET['state']);
}
try {
	$accessToken = $helper->getAccessToken();
} catch(Facebook\Exceptions\FacebookResponseException $e) {
	// When Graph returns an error
	echo 'Graph returned an error: ' . $e->getMessage();
	exit;
} catch(Facebook\Exceptions\FacebookSDKException $e) {
	// When validation fails or other local issues
	echo 'Facebook SDK returned an error: ' . $e->getMessage();
	exit;
}

if (isset($accessToken)) {
	// The OAuth 2.0 client handler helps us manage access tokens
	$oAuth2Client = $fb->getOAuth2Client();

	// Get the access token metadata from /debug_token
	$tokenMetadata = $oAuth2Client->debugToken($accessToken);

	// Validation (these will throw FacebookSDKException's when they fail)
	$tokenMetadata->validateAppId($social_data['facebook_id']); // Replace {app-id} with your app id
	// If you know the user ID this access token belongs to, you can validate it here
	//$tokenMetadata->validateUserId('123');
	$tokenMetadata->validateExpiration();

	if (! $accessToken->isLongLived()) {
		// Exchanges a short-lived access token for a long-lived one
		try {
			$accessToken = $oAuth2Client->getLongLivedAccessToken($accessToken);
		} catch (Facebook\Exceptions\FacebookSDKException $e) {
			echo "<p>Error getting long-lived access token: " . $e->getMessage() . "</p>\n\n";
			exit;
		}
	}

	$response		= $fb->get('/me?fields=name,email', $accessToken);
	$user_profile		= $response->getGraphUser();

	$login_info["id"]					= "1F".$user_profile->getId();
	$login_info["name"]				= $user_profile->getName();
	$login_info["link"]				= $user_profile->getLink();
	$login_info["email"]				= $user_profile->getEmail();  
	$login_info["thumbnail"]		= 'http://graph.facebook.com/'.$user_profile->getId().'/picture?type=normal';
	$login_info["access_token"]	= $accessToken;
} else {
	if(empty($_REQUEST['type']) || (!empty($_REQUEST['error']) && $_REQUEST['error']=="access_denied") ){
		echo '<script>self.close()</script>';
	}else{
		$login_url			= $helper->getLoginUrl($redirect_uri, ['email']);  
		header('Location: '. $login_url);
		exit;
	}	
}
?>