<?php
class Instagram
{
	const OAUTH_URL		= "https://api.instagram.com/oauth/access_token";

	private $id					= "";
	private $secret				= "";
	private $oauth_url		= "";
	private $code				= "";
	private $user;
	private $redirect_uri		= "";
	private $access_token	= "";
	private $refresh_token	= "";
	private $token_type		= "";
	private $expires_in		= "";

	public function __construct($id,$secret,$code,$redirect_uri) {		
		$this->id					= $id;
		$this->secret				= $secret;		
		$this->code				= $code;
		$this->redirect_uri		= trim(urlencode($redirect_uri));
		$this->oauth();
	}

	private function oauth(){
		$options			= array( 
			CURLOPT_URL => self::OAUTH_URL,
			CURLOPT_POSTFIELDS => sprintf( 'grant_type=authorization_code&client_id=%s&client_secret=%s&redirect_uri=%s&code=%s&state=%s', $this->id,$this->secret,$this->redirect_uri,$this->code,$this->state)
		);
		$response		= json_decode($this->request($options));

		if(!empty($response->access_token)){
			$this->access_token		= $response->access_token;
			$this->user					= $response->user;
		}
	}	
	public function getProfile(){
		return $this->user;
	}

	public function get($url, $opt=array()){
		$options			= array( 
			CURLOPT_URL => $url, 
			CURLOPT_HTTPHEADER =>array("Authorization: ".$this->token_type." ".$this->access_token)
		);
		if(!empty($opt)){
			foreach($opt  as $key => $value){
				$options[$key]		= $value;
			}
		}
		$response		= json_decode($this->request($options));
		return $response;
	}

	public function request($opt=array()) {
		$options				= array( 
			CURLOPT_SSL_VERIFYPEER => false, 
			CURLOPT_SSLVERSION => 1, 
			CURLOPT_POST => true, 
			CURLOPT_POSTFIELDS => false, 
			CURLOPT_RETURNTRANSFER => true
		);		

		if(!empty($opt)){
			foreach($opt  as $key => $value){
				$options[$key]		= $value;
			}
		}

		$curl_handle			= curl_init(); 
		curl_setopt_array($curl_handle, $options); 
		$response	= curl_exec($curl_handle); 
		curl_close($curl_handle);
		return $response;
    }
}
?>