<?php

class Naver
{
	const OAUTH_URL		= "https://nid.naver.com/oauth2.0/token";

	private $id					= "";
	private $secret				= "";
	private $oauth_url		= "";
	private $code				= "";
	private $state				= "";
	private $redirect_uri		= "";
	private $access_token	= "";
	private $refresh_token	= "";
	private $token_type		= "";
	private $expires_in		= "";

	public function __construct($id,$secret,$code,$state,$redirect_uri) {		
		$this->id					= $id;
		$this->secret				= $secret;
		$this->code				= $code;
		$this->state				= $state;
		$this->redirect_uri		= $redirect_uri;
		$this->oauth();
	}

	private function oauth(){
		$options			= array( 
			CURLOPT_URL => self::OAUTH_URL,
			CURLOPT_POSTFIELDS => sprintf( 'grant_type=authorization_code&client_id=%s&client_secret=%s&redirect_uri=%s&code=%s&state=%s', $this->id,$this->secret,$this->redirect_uri,$this->code,$this->state)
		);
		$response		= json_decode($this->request($options));
		if(!empty($response->access_token)){
			$this->access_token		= $response->access_token;
			$this->refresh_token		= $response->refresh_token;
			$this->token_type		= $response->token_type;
			$this->expires_in			= $response->expires_in;
		}
	}
	public function get($url, $opt=array()){
		$options			= array( 
			CURLOPT_URL => $url, 
			CURLOPT_HTTPHEADER =>array("Authorization: ".$this->token_type." ".$this->access_token)
		);
		if(!empty($opt)){
			foreach($opt  as $key => $value){
				$options[$key]		= $value;
			}
		}
		$response		= $this->request($options);
		$xml				= new SimpleXMLElement($response);	  
		$data				= array();
		if($xml->result[0]->resultcode == '00'){
			foreach($xml->response->children() as $key => $value){
				$data[trim($key)] = trim($value);
			}
		}
		return json_encode($data);
	}

	public function request($opt=array()) {
		$options				= array( 
			CURLOPT_SSL_VERIFYPEER => false, 
			CURLOPT_SSLVERSION => 1, 
			CURLOPT_POST => true, 
			CURLOPT_POSTFIELDS => false, 
			CURLOPT_RETURNTRANSFER => true
		);
		if(!empty($opt)){
			foreach($opt  as $key => $value){
				$options[$key]		= $value;
			}
		}
		$curl_handle			= curl_init(); 
		curl_setopt_array($curl_handle, $options); 
		$response	= curl_exec($curl_handle); 
		curl_close($curl_handle);
		return $response;
    }
}





?>