<?php
add_filter('query_vars','mbw_sociallogin_add_trigger',10,1);
if(!function_exists('mbw_sociallogin_add_trigger')){	
	function mbw_sociallogin_add_trigger($vars) {
		$vars[] = 'mb_social';
		$vars[] = 'source';
		return $vars;
	}
}
add_action('template_redirect', 'mbw_sociallogin_trigger_check');
if(!function_exists('mbw_sociallogin_trigger_check')){	
	function mbw_sociallogin_trigger_check() {
		if((get_query_var('mb_social')) == "login" || (get_query_var('source')) == "twitter") {
			global $mdb,$mstore,$wpdb,$mb_admin_tables,$mb_fields;
			require_once(MBW_PLUGIN_PATH."plugins/sociallogin/login.php");
			exit;
		}else if((get_query_var('mb_social')) == "user_deletion") {

			if(!empty($_REQUEST["auth"])){
				$platform			= $_REQUEST["auth"];
				if($platform=="facebook" && !empty($_REQUEST['signed_request'])){
					$signed_request			= $_REQUEST["signed_request"];					
					$facebook_secret		= trim(mbw_get_option('facebook_secret'));
					list($encoded_sig, $payload) = explode('.', $signed_request, 2);
					$sig = base64_decode(strtr($encoded_sig, '-_', '+/'));
					$data = json_decode(base64_decode(strtr($payload, '-_', '+/')), true); 
					if (strtoupper($data['algorithm']) !== 'HMAC-SHA256') { 
						//log_trace('Unknown algorithm. Expected HMAC-SHA256'); 
						exit('Unknown algorithm. Expected HMAC-SHA256'); 
					} 
					// check sig 
					$expected_sig = hash_hmac('sha256', $payload, $secret, $raw = true); 
					if ($sig !== $expected_sig) { 
						//log_trace('Bad Signed JSON signature!'); 
						exit('Bad Signed JSON signature!'); 
					}
					if($data){
						log_trace($data);
					}					
				}
			}			
		}
	}
}
if(!function_exists('mbw_print_social_scripts')){	
	function mbw_print_social_scripts(){
		require(MBW_PLUGIN_PATH."plugins/sociallogin/setup.php");

		$social_login	= "";
		$social_login	.= '<script type="text/javascript">';
		$social_login	.= 'var kakaoJavascriptKey		= "'.$social_data['kakao_javascript_key'].'";';
		$social_login	.= 'var bitlyApiId					= "'.$social_data['bitly_id'].'";';
		$social_login	.= 'var bitlyApiKey				= "'.$social_data['bitly_key'].'";';
		$social_login	.= '</script>';
		global $mb_scripts; 
		$mb_scripts[]		= $social_login;
		
		//dev2 2022-10-16
		loadScript("//developers.kakao.com/sdk/js/kakao.min.js","kakao-sdk");
		loadScript(MBW_PLUGIN_URL."plugins/sociallogin/js/common.js","mb-business-sociallogin",array('jquery','kakao-sdk'));
		if(!empty($social_data['kakao_javascript_key']) && mbw_get_trace("mbw_head_meta")!="")	{
			//loadScript(MBW_PLUGIN_URL."plugins/sociallogin/js/kakao.link2.js","mb-kakao-link2",array('jquery','kakao-sdk'));		
		}
		loadStyle(MBW_PLUGIN_URL."plugins/sociallogin/css/style.css","mb-business-sociallogin");
	}
}
add_action('wp_print_scripts', 'mbw_print_social_scripts',1);

if(!function_exists('mbw_wp_sociallogin')){	
	function mbw_wp_sociallogin(){
		mbw_login_form_sociallogin("WP");
	}
}
if(!function_exists('mbw_login_widget_form_sociallogin')){	
	function mbw_login_widget_form_sociallogin($mode=""){
		mbw_login_form_sociallogin($mode="", "24");
	}
}
if(!function_exists('mbw_get_sociallogin_script')){	
	function mbw_get_sociallogin_script($mode=""){
		$login_script	= "";
		if(mbw_get_trace("mbw_get_sociallogin_script")==""){
			mbw_add_trace("mbw_get_sociallogin_script");		
			loadScript(MBW_PLUGIN_URL.'assets/js/common.js');
			$login_script	.= '<script type="text/javascript">';
			$login_script	.= 'var socialIntervalHandler;';
			$login_script	.= 'var objSocialPopup;';
			
			$site_url			= mbw_get_http_url(MBW_HOME_URL);
			$login_script	.= 'function checkSocialLoginStatus(){';
				$login_script	.= 'var data				= "mode=write&board_action=user_is_login&board_name=user_register";';
				$login_script	.= 'sendDataRequest2(mb_urls["user_api"], data, checkSocialLoginStatusHandler);';
			$login_script	.= '}';
			$login_script	.= 'function checkSocialLoginStatusHandler(response){';
				$login_script	.= 'if(response && response.state == "success"){';
					$login_script	.= 'if(response.data.login=="true"){';
						$login_script	.= 'clearInterval(socialIntervalHandler);';
						$login_script	.= 'if(objSocialPopup) objSocialPopup.close();';
						
						$login_script	.= 'var parent_window	= window;';
						$login_script	.= 'var parent_path		= parent_window.location.pathname;';
						$login_script	.= 'var parent_href		= parent_window.location.href;';
						
						$login_script	.= 'if(parent_href.indexOf("redirect_to")!=-1){';
							$login_script	.= 'var end_index		= parent_href.length;';
							$login_script	.= 'if(parent_href.indexOf("&")!=-1) end_index		= parent_href.indexOf("&");';
							$login_script	.= 'var redirect_to		= parent_href.substring(parent_href.indexOf("redirect_to=")+12,end_index);';
							$login_script	.= 'if(redirect_to.indexOf(parent_window.location.host)<20) parent_window.location.href =decodeURIComponent(redirect_to);';			
						$login_script	.= '}else if(parent_path.indexOf("/wp-login.php")!=-1){';	//워드프레스 로그인 화면
							if(has_filter('mf_user_login_redirect_to')){		//망보드 로그인 리다이렉트 필터가 존재할 경우 실행
								$login_script	.= 'parent_window.location.href =decodeURIComponent("'.apply_filters("mf_user_login_redirect_to",$site_url).'");';
							}else{
								$login_script	.= 'parent_window.location.href =decodeURIComponent("'.$site_url.'");';
							}
						$login_script	.= '}else{';
							if(has_filter('mf_user_login_redirect_to')){		//망보드 로그인 리다이렉트 필터가 존재할 경우 실행
								$redirect_url		= apply_filters("mf_user_login_redirect_to",'');
								if(!empty($redirect_url) && $redirect_url!='reload'){
									$login_script	.= 'parent_window.location.href =decodeURIComponent("'.apply_filters("mf_user_login_redirect_to",$site_url).'");';
								}else{
									$login_script	.= 'parent_window.location.reload();';
								}
							}else{
								$login_script	.= 'parent_window.location.reload();';	
							}
						$login_script	.= '}';						
						
					$login_script	.= '}';
				$login_script	.= '}';
			$login_script	.= '}';
			$login_script	.= 'function requestSocialLoginData(type){';
				$login_script	.= 'var w = 464; var h = 595;';
				$login_script	.= 'if(type=="kakao"){w	= 464;h	= 595;}else if(type=="naver"){w	= 580;h	= 720;}else if(type=="google"){w	= 440;h	= 570;}else if(type=="facebook"){w	= 996;h	= 660;}else if(type=="google"){w	= 934;h	= 643;}';
				$login_script	.= 'var remember	= 0;';
				$login_script	.= 'if(document.getElementById("rememberme") && document.getElementById("rememberme").checked) remember	= 1;';	

				$login_script	.= 'if(typeof(mb_hybrid_app)!=="undefined" && mb_hybrid_app!=""){';
					$login_script	.= 'if(type=="google" || type=="facebook" || type=="naver" || type=="kakao" || type=="apple"){';
						$login_script	.= 'homeSendMessage({"mode":"SOCIAL_LOGIN_POPUP","value": type});';
					$login_script	.= '}else{';
						$login_script	.= 'objSocialPopup = openWindow("'.mbw_check_url(MBW_HOME_URL).'/?mb_social=login&type="+type+"&user_mode='.$mode.'&user_remember="+remember,"socialPopup","top=100, left=100, width="+w+"px, height="+h+"px");';
					$login_script	.= '}';
				$login_script	.= '}else{';
					$login_script	.= 'objSocialPopup = openWindow("'.mbw_check_url(MBW_HOME_URL).'/?mb_social=login&type="+type+"&user_mode='.$mode.'&user_remember="+remember,"socialPopup","top=100, left=100, width="+w+"px, height="+h+"px");';
				$login_script	.= '}';

				if(mbw_get_vars("device_type")=="desktop"){
					$login_script	.= 'if(type=="naver"){';
						$login_script	.= 'var socialIntervalHandler = setInterval(checkSocialLoginStatus,4000);';
					$login_script	.= '}';
				}
			$login_script	.= '}';
			$login_script	.= '</script>';		
		}
		return $login_script;
	}
}
if(!function_exists('mbw_login_form_sociallogin')){	
	function mbw_login_form_sociallogin($mode="", $size="", $echo = true){

		if(!mbw_get_option("social_login")) return;
		
		$social_login					= "";
		if(!empty($size)){
			$login_icon_width			= $size;
			$login_icon_height			= $size;
		}else{
			$login_icon_width			= "33";
			$login_icon_height			= "33";
		}	
		$social_login_title		= mbw_get_option("social_login_title");
		$social_login	.=	mbw_get_sociallogin_script($mode);
		$social_login	.= '<div class="clear"></div>';
		$social_login	.= '<div class="mb-social mb-social-login">';
			$social_login	.= '<div class="mb-social-title">'.$social_login_title.'</div>';
			$social_login	.= '<div class="mb-social-btn-box">';			
				$social_login	.= mbw_get_sociallogin_button($login_icon_width,$login_icon_height);
			$social_login	.= '</div>';
		$social_login	.= '</div>';

		if($echo) echo $social_login;
		else return $social_login;
	}
}
add_action('mbw_login_form', 'mbw_login_form_sociallogin');
add_action('mbw_login_widget_form', 'mbw_login_widget_form_sociallogin');
add_action('login_form', 'mbw_wp_sociallogin');
add_action('register_form', 'mbw_wp_sociallogin');

if(!function_exists('mbw_get_sociallogin_button')){	
	function mbw_get_sociallogin_button($width,$height=0,$function="requestSocialLoginData"){
		if(!mbw_get_option("social_login")) return;
		if(empty($height)) $height		= $width;
		$social_login	=	"";

		$social_login	.=	mbw_get_sociallogin_script();
		//kakao login
		if(mbw_get_option('social_kakao_login')) $social_login	.= '<a style="margin-right:10px;" onclick="'.$function.'(\'kakao\')"><img src="'.MBW_PLUGIN_URL.'plugins/sociallogin/images/icon_kakao.png" style="max-width:'.$width.'px;max-height:'.$height.'px;" title="Login with Kakao" alt="Login with Kakao" class="radius-4"></a>';
		
		//naver login
		if(mbw_get_option('social_naver_login')) $social_login	.= '<a class="margin-right-10" onclick="'.$function.'(\'naver\')"><img src="'.MBW_PLUGIN_URL.'plugins/sociallogin/images/icon_naver.png" style="max-width:'.$width.'px;max-height:'.$height.'px;" title="Login with Naver" alt="Login with Naver" class="radius-4"></a>';

		//google login
		if(mbw_get_option('social_google_login')) $social_login	.= '<a class="margin-right-10" onclick="'.$function.'(\'google\')"><img src="'.MBW_PLUGIN_URL.'plugins/sociallogin/images/icon_google.png" style="max-width:'.$width.'px;max-height:'.$height.'px;" title="Login with Google Plus" alt="Login with Google Plus" class="radius-4"></a>';
		
		//facebook login
		if(mbw_get_option('social_facebook_login')) $social_login	.= '<a class="margin-right-10" onclick="'.$function.'(\'facebook\')"><img src="'.MBW_PLUGIN_URL.'plugins/sociallogin/images/icon_facebook.png" style="max-width:'.$width.'px;max-height:'.$height.'px;" title="Login with Facebook" alt="Login with Facebook" class="radius-4"></a>';		

		//instagram login
		if(mbw_get_option('social_instagram_login')) $social_login	.= '<a class="margin-right-10" onclick="'.$function.'(\'instagram\')"><img src="'.MBW_PLUGIN_URL.'plugins/sociallogin/images/icon_instagram.png" style="max-width:'.$width.'px;max-height:'.$height.'px;" title="Login with Twitter" alt="Login with instagram" class="radius-4"></a>';

		//twitter login
		if(mbw_get_option('social_twitter_login')) $social_login	.= '<a onclick="'.$function.'(\'twitter\')"><img src="'.MBW_PLUGIN_URL.'plugins/sociallogin/images/icon_twitter.png" style="max-width:'.$width.'px;max-height:'.$height.'px;" title="Login with Twitter" alt="Login with Twitter" class="radius-4"></a>';

		return $social_login;
	}
}
if(!function_exists('mbw_get_social_login')){	
	function mbw_get_social_login($size="24"){
		if(mbw_is_login()) return "";
		return mbw_login_form_sociallogin("",$size,false);
	}
}
if(!function_exists('mbw_get_social_sharing')){	
	function mbw_get_social_sharing($size="33",$align="right"){
		$social_sharing				= "";

		if(!empty($size)){
			$share_icon_width			= $size;
			$share_icon_height			= $size;
		}else{
			$share_icon_width			= "33";
			$share_icon_height			= "33";	
		}

		$social_sharing_align		= $align;	
		$social_sharing_title			= mbw_get_option("social_sharing_title");
		$social_sharing	.= '<div class="clear"></div><div class="mb-social mb-social-sharing" style="text-align:'.$social_sharing_align.'">';
			$social_sharing	.= '<div  class="mb-social-title">'.$social_sharing_title.'</div>';
			$social_sharing	.= '<div class="mb-social-btn-box">';

			$social_sharing_style		= "margin-right:10px;";
			if(mbw_get_vars("device_type")!="desktop") $social_sharing_style		= "margin-right:7px;";
							
				//google sharing
				//$social_sharing	.= '<a style="'.$social_sharing_style.'" onclick="sendSocialShare(\'google\',520,480)"><img src="'.MBW_PLUGIN_URL.'plugins/sociallogin/images/icon_google.png" style="max-width:'.$share_icon_width.'px;max-height:'.$share_icon_height.'px;" title="Google Plus Sharing" alt="Google Plus Sharing" class="radius-4"></a>';

				//kakao sharing
				if(mbw_get_option('kakao_javascript_key')!="" && mbw_get_trace("mbw_head_meta")!="")
					$social_sharing	.= '<a style="'.$social_sharing_style.'" href="javascript:;"  onclick="sendSocialShare(\'kakao\',427,789);return false;" class="mb-kakao-link-btn2"><img src="'.MBW_PLUGIN_URL.'plugins/sociallogin/images/icon_kakao.png" style="max-width:'.$share_icon_width.'px;max-height:'.$share_icon_height.'px;" title="Kakao Sharing" alt="Kakao Sharing" class="radius-4"></a>';
				
				//facebook sharing
				$social_sharing	.= '<a style="'.$social_sharing_style.'" onclick="sendSocialShare(\'facebook\',979,551);return false;"><img src="'.MBW_PLUGIN_URL.'plugins/sociallogin/images/icon_facebook.png" style="max-width:'.$share_icon_width.'px;max-height:'.$share_icon_height.'px;" title="Facebook Sharing" alt="Facebook Sharing" class="radius-4"></a>';				

				//naver_blog sharing
				$social_sharing	.= '<a style="'.$social_sharing_style.'" onclick="sendSocialShare(\'naver_blog\',557,590);return false;"><img src="'.MBW_PLUGIN_URL.'plugins/sociallogin/images/icon_naver_blog.png" style="max-width:'.$share_icon_width.'px;max-height:'.$share_icon_height.'px;" title="Naver Blog Sharing" alt="Naver Blog Sharing" class="radius-4"></a>';

				//kakao story sharing
				//$social_sharing	.= '<a style="'.$social_sharing_style.'" onclick="sendSocialShare(\'kakao_story\',653,471);return false;"><img src="'.MBW_PLUGIN_URL.'plugins/sociallogin/images/icon_kakao_story.png" style="max-width:'.$share_icon_width.'px;max-height:'.$share_icon_height.'px;" title="Kakao Story Sharing" alt="Kakao Story Sharing" class="radius-4"></a>';

				//naver_line sharing
				if(mbw_get_vars("device_type")!="desktop")
					$social_sharing	.= '<a style="'.$social_sharing_style.'" onclick="sendSocialShare(\'naver_line\',557,590);return false;"><img src="'.MBW_PLUGIN_URL.'plugins/sociallogin/images/icon_naver_line.png" style="max-width:'.$share_icon_width.'px;max-height:'.$share_icon_height.'px;" title="Naver Line Sharing" alt="Naver Line Sharing" class="radius-4"></a>';

				//mail sharing
				$social_sharing	.= '<a style="'.$social_sharing_style.'" onclick="sendSocialShare(\'mail\',600,600);return false;"><img src="'.MBW_PLUGIN_URL.'plugins/sociallogin/images/icon_mail.png" style="max-width:'.$share_icon_width.'px;max-height:'.$share_icon_height.'px;" title="Mail Sharing" alt="Mail Sharing" class="radius-4"></a>';

				//naver_band sharing
				$social_sharing	.= '<a style="'.$social_sharing_style.'" onclick="sendSocialShare(\'naver_band\',410,540);return false;"><img src="'.MBW_PLUGIN_URL.'plugins/sociallogin/images/icon_naver_band.png" style="max-width:'.$share_icon_width.'px;max-height:'.$share_icon_height.'px;" title="Naver Band Sharing" alt="Naver Band Sharing" class="radius-4"></a>';

				//twitter sharing
				$social_sharing	.= '<a onclick="sendSocialShare(\'twitter\',680,450);return false;"><img src="'.MBW_PLUGIN_URL.'plugins/sociallogin/images/icon_twitter.png" style="max-width:'.$share_icon_width.'px;max-height:'.$share_icon_height.'px;" title="Twitter Sharing" alt="Twitter Sharing" class="radius-4"></a>';				

			$social_sharing	.= '</div>';
		$social_sharing	.= '</div>';
		return $social_sharing;
	}
}
add_shortcode("mb_social_share", 'mbw_create_social_share');
if(!function_exists('mbw_create_social_share')){
	function mbw_create_social_share($args){
		$social_sharing_align		= 'left';
		if(mbw_get_vars("device_type")!="mobile"){
			$social_sharing				= mbw_get_social_sharing("33",$social_sharing_align);
		}else{
			$social_sharing				= mbw_get_social_sharing("28",$social_sharing_align);
		}
		return $social_sharing;
	}
}
if(!function_exists('mbw_content_sharing')){	
	function mbw_content_sharing($content){
		if(isset($_GET['print']) && $_GET['print']=="mb_page")  return $content;

		if(get_the_content()!=$content) return $content;
		else if(!mbw_get_option("social_sharing") || mbw_get_trace("mbw_head")=="" || !is_singular()) return $content;

		if ( isset( $_GET['post'] ) ) $post			= get_post($_GET['post']);
		else $post			= $GLOBALS['post'];
		$social_share_meta			= get_post_meta($post->ID, 'mb_post_social_share',true);
		if(!empty($social_share_meta) && $social_share_meta["mb_use_post_social_share"]=="0") return $content;

		$social_sharing_position	= mbw_get_option("social_sharing_position");
		$social_sharing_align		= mbw_get_option("social_sharing_align");	
		if(mbw_get_vars("device_type")!="mobile"){
			$social_sharing				= mbw_get_social_sharing("33",$social_sharing_align);
		}else{
			$social_sharing				= mbw_get_social_sharing("28",$social_sharing_align);
		}

		if($social_sharing_position=="top"){
			echo $social_sharing;
		}else if($social_sharing_position=="top-bottom"){
			echo $social_sharing;
			if(!empty($content)) $social_sharing		= '<div class="mb-social-empty-box"></div>'.$social_sharing;
			$content		= $content.$social_sharing;
		}else{
			if(!empty($content)) $social_sharing		= '<div class="mb-social-empty-box"></div>'.$social_sharing;
			$content		= $content.$social_sharing;
		}

		return $content;
	}
}
add_filter( 'the_content', 'mbw_content_sharing', 1);
if(!function_exists('mbw_init_social_share_metabox')){	
	function mbw_init_social_share_metabox(){
		if(!mbw_get_option("social_sharing")) return;
		add_action('add_meta_boxes', 'mbw_set_social_share_metabox');
		add_action('save_post', 'mbw_save_social_share_metabox');	
	}
}
if(!function_exists('mbw_set_social_share_metabox')){	
	function mbw_set_social_share_metabox( $post_type ) {
		$post_types			= array('post', 'page');
		if ( in_array( $post_type, $post_types )) 
			add_meta_box( 'mb_social_share_meta', 'MangBoard Social Share', 'mbw_add_social_share_metabox', $post_type, 'normal', 'high' );
	}
}
if(!function_exists('mbw_add_social_share_metabox')){	
	function mbw_add_social_share_metabox(){
		if ( isset( $_GET['post'] ) ) {
			$post			= get_post($_GET['post']);
		}else{
			$post			= $GLOBALS['post'];
		}
		$post_id						= $post->ID;
		$social_share				= array("mb_use_post_social_share"=>"");
		if(!empty($post_id))
			$post_meta			= get_post_meta($post_id, 'mb_post_social_share',true);
		if(!empty($post_meta)) 
			$social_share					= array_merge($social_share, $post_meta);
		
		$checked1		= "";
		$checked2		= "";
		if($social_share["mb_use_post_social_share"]=="0") $checked2		= ' checked=""';
		else $checked1		= ' checked=""';

		$metabox		= "";
		$metabox		.= '<div style="padding:12px;border:1px solid #eee">';

		$metabox		.= '<label for="mb_use_post_social_share1"><input type="radio" name="mb_use_post_social_share" id="mb_use_post_social_share1" value="1"'.$checked1.'>사용</label><label for="mb_use_post_social_share2" style="margin-left:20px;"><input type="radio" name="mb_use_post_social_share" id="mb_use_post_social_share2" value="0"'.$checked2.'>사용안함</label>';

		$metabox		.= '</div>';
		echo $metabox;	
	}
}
if(!function_exists('mbw_save_social_share_metabox')){	
	function mbw_save_social_share_metabox($post_id){
		if ( $post_id === null ) return false;

		if ( wp_is_post_revision( $post_id ) ) 
			$post_id = wp_is_post_revision( $post_id );

		$social_share				= array("mb_use_post_social_share"=>"");
		if(!empty($post_id))
			$post_meta			= get_post_meta($post_id, 'mb_post_social_share',true);
		if(!empty($post_meta)) 
			$social_share					= array_merge($social_share, $post_meta);

		if(isset($_POST["mb_use_post_social_share"])){
			$social_share["mb_use_post_social_share"]				= esc_attr($_POST["mb_use_post_social_share"]);

			if($social_share["mb_use_post_social_share"]=="0")
				update_post_meta($post_id, 'mb_post_social_share', $social_share);
			else if(!empty($post_meta)){
				delete_post_meta($post_id, 'mb_post_social_share');
			}
		}
	}
}
add_action('admin_init', 'mbw_init_social_share_metabox');
?>